﻿@model PROJETMODELE.Models.VML.TP.VenteVM
@{
    Layout = null;
    string identifiant = TempData["id"].ToString();
    PROJETMODELE.Tools.Services service = new PROJETMODELE.Tools.Services();
    string Solde_Liquide_str = service.SeparateurMillier(Model.Solde_Liquide);

    string Solde_emballage_str =  service.SeparateurMillier(Model.Solde_Emballage);
}
<script src="~/Scripts/EditeJS.js"></script>
<input id="validerUrl" value="/Vente/Modifier/" type="hidden" />
<div id="formulaire">
    <div>Modification Facture N&deg : @Model.NUM_DOC</div>
    <div class="forms">

        @using (Html.BeginForm())
        {
            @Html.AntiForgeryToken()
            @Html.ValidationSummary(true) 
             @Html.Hidden("supprimerUrl", "/Vente/Supprimer_Detail_Edit_Liquide/")
            @Html.Hidden("materielUrl", "/Vente/Edit_Detail_Liquide/" + identifiant)
            @Html.Hidden("LoardUrlm", "/Vente/ajaxCmdLiquideDetail/" + identifiant)  
            @Html.Hidden("LoardUrlmemballage", "/Vente/ajaxCmdEmballageDetail/" + identifiant)   
            @Html.Hidden("supprimer_emballageUrl", "/Vente/Supprimer_Detail_Edit_Emballage/")
            @Html.Hidden("materiel_emballageUrl", "/Vente/Edit_Detail_Emballage/" + identifiant)   
            <div id='jqxWidget'>
                <div id='jqxTabs'>
                    <ul>                     
                        <li style="margin-left: 30px;"> Facturation</li>
                        <li> Liquide</li>
                        <li> Retour Emballage</li>
                    </ul>
                   <div class="section">
                        <table style="width: 60%; margin: 0 auto;">
                            <tr>
                                <td>@Html.LabelFor(model=>model.ID_Client)</td>
                                <td>@HTML_OUF.DropDownList("ID_Client",Model.ID_Client,TempData["ID_Client"] as SelectList,"280")</td>                                
                            </tr>                       
                            <tr>
                                <td >@Html.LabelFor(model=>model.Nom_Client)</td>
                                <td align="left">@Html.EditorFor(model=>model.Nom_Client)</td>                             
                            </tr>
                            
                              
                        </table>
                       <table style="width: 100%; margin: 0 auto">
                            
                            <tr>
                                <td >
                                    <table style="width: 100%; margin: 0 auto; border-collapse: collapse;" class="encadrer_tout">
                                        <tr>
                                            <th colspan="2" style="background-color:#999999">Aperçu Compte</th>
                                        </tr>
                                        
                                         <tr>
                                            <td>@Html.Label("Solde Liquide")</td>
                                            <td >@Html.TextBox("Solde_Initial_Liquide", Solde_Liquide_str)</td>
                                        </tr>
                                        <tr>
                                            <td>@Html.Label("Solde Emballage")</td>
                                            <td >@Html.TextBox("Solde_Initial_Emballage", Solde_emballage_str)</td>
                                        </tr>

                                        <tr>
                                            <td>@Html.LabelFor(model => model.Versement_Liquide)</td>
                                            <td>
                                                @Html.TextBoxFor(model => model.Versement_Liquide)
                                            </td>
                                        </tr>
                                        <tr>
                                            <td>@Html.LabelFor(model => model.Consigne_Emballage)</td>
                                            <td>
                                                @Html.TextBoxFor(model => model.Consigne_Emballage)
                                            </td>
                                        </tr>
                                        <tr>
                                            <td>@Html.Label("Solde Final Liquide")</td>
                                            <td>

                                            @Html.TextBox("Solde_Final_Liquide")
                                            </td>
                                        </tr>
                                        <tr>
                                            <td>@Html.Label("Solde Final Emballage")</td>
                                            <td>@Html.TextBox("Solde_Final_Emballage")</td>
                                        </tr>
                                         
                                    </table>
                                </td>
                                <td style="vertical-align:top">
                                    <table style="width: 100%; margin: 0 auto; border-collapse: collapse;" class="encadrer_tout">
                                        <tr>
                                            <th colspan="2" style="background-color:#808080">Récap Facture</th>
                                        </tr>
                                        <tr>
                                            <td>@Html.Label("Montant Liquide")</td>
                                            <td >@Html.TextBox("Montant_Liquide",@TempData["Montant_Liquide"].ToString())</td>
                                        </tr>
                                        <tr>
                                            <td>@Html.Label("Montant Emballage")</td>
                                            <td>@Html.TextBox("Montant_Emballage",TempData["Montant_Emballage"].ToString())
                                            </td>
                                        </tr>
                                        <tr>
                                            <td>@Html.Label("Retour Emballage")</td>
                                            <td>@Html.TextBox("Montant_Emballage_Retour",TempData["Montant_Retour_Emballage"].ToString())
                                            </td>
                                        </tr>
                                        <tr>
                                            <td colspan="2" style="text-align:center; padding-top:50px">
                                                <div  style="font-size:2em; font-weight:bold"><span id="Montant_Facture">@TempData["Montant"].ToString()</span> FCFA</div>
                                            </td>
                                        </tr>
                                       
                                    </table>
                                </td>
                            </tr> 
                                                                                                                                       
                        </table>
                       <table class="boutons" style="width: 60%; margin: 0 auto;">
                            <tr>
                                <td style=" text-align: center">
                                    <button title="Valider"  type="submit" id="jqxButton" class="btn btn-default oufbutton send"><i class="ouf-ok"></i>Valider</button>
                                
                                </td>
                                
                            </tr> 
                        </table>
                   </div>
                    <div class="section">
                        <table style="width: 70%; margin: 0 auto; border-collapse: collapse;" class="encadrer_tout">
                            <tr>
                                <th colspan="3" style="background-color:#999999">Produit</th>
                                <th colspan="3" style="background-color:#808080">Emballage</th>
                            </tr>
                            <tr>
                                <td width="180px">
                                    @Html.LabelFor(model=>model.ID_Produit)
                                </td>
                                <td width="180px">
                                    @Html.LabelFor(model=>model.Quantite_Casier_Liquide)
                                </td>
                                <td width="180px">
                                    @Html.LabelFor(model=>model.Quantite_Bouteille_Liquide)
                                </td>
                                <td width="180px">
                                    @Html.LabelFor(model=>model.Quantite_Casier_Emballage)
                                </td>
                                <td width="180px">
                                    @Html.LabelFor(model=>model.Quantite_Plastique_Emballage)
                                </td>
                                <td width="180px">
                                    @Html.LabelFor(model=>model.Quantite_Bouteille_Emballage)
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    @HTML_OUF.DropDownList("ID_Produit", TempData["ID_Produit"] as SelectList,"280")
                                </td>
                                <td>
                                    @Html.TextBoxFor(model=>model.Quantite_Casier_Liquide)
                                </td>
                                <td>
                                    @Html.TextBoxFor(model=>model.Quantite_Bouteille_Liquide)
                                </td>
                                <td>
                                    @Html.TextBoxFor(model=>model.Quantite_Casier_Emballage)
                                </td>
                                <td>
                                    @Html.TextBoxFor(model=>model.Quantite_Plastique_Emballage)
                                </td>
                                <td>
                                    @Html.TextBoxFor(model=>model.Quantite_Bouteille_Emballage)
                                </td>
                            </tr>
                            
                        </table>
                       <table  style="width: 60%; margin: 0 auto;" class="boutons">
                           <tr>
                                <td style="text-align: left">
                                    <button title="Supprimer" value="Supprimer" type="button" id="supprimer" class="btn btn-default oufbutton  action"><i class="ouf-delete"></i>Supprimer</button>
                                </td>
                                <td style="text-align: left" colspan="2">
                                    <button title="Ajouter" value="Ajouter" type="button" id="materiel" class="btn btn-default oufbutton  action"><i class='ouf-ok'></i>Ajouter</button>
                                </td>
                               
                            </tr>
                       </table>
                        <div id="gradesm"></div>
                       
                    </div>
                    <div class="section">
                                                                      
                       <table style="width: 40%; margin: 0 auto;">
                            <tr>
                                
                                <td width="50px">@Html.LabelFor(model=>model.ID_Emballage)</td>
                                <td >@Html.LabelFor(model=>model.Quantite_Casier_Emballage_Retour)</td>
                                <td >@Html.LabelFor(model=>model.Quantite_Plastique_Emballage_Retour)</td>
                                <td >@Html.LabelFor(model=>model.Quantite_Bouteille_Emballage_Retour)</td>
                            </tr>
                             
                            
                                                                                                     
                            <tr>                                
                                <td width="50px">@Html.Label("C12")</td>
                                <td >@Html.TextBoxFor(model=>model.Casier_12)</td>
                                <td >@Html.TextBoxFor(model=>model.Plastique_12)</td>
                                <td >@Html.TextBoxFor(model=>model.Bouteille_12)</td>
                            </tr>
                            <tr>                                
                                <td width="50px">@Html.Label("C15")</td>
                                <td >@Html.TextBoxFor(model=>model.Casier_15)</td>
                                <td >@Html.TextBoxFor(model=>model.Plastique_15)</td>
                                <td >@Html.TextBoxFor(model=>model.Bouteille_15)</td>
                            </tr>
                            <tr>                                
                                <td width="50px">@Html.Label("C24")</td>
                                <td >@Html.TextBoxFor(model=>model.Casier_24)</td>
                                <td >@Html.TextBoxFor(model=>model.Plastique_24)</td>
                                <td >@Html.TextBoxFor(model=>model.Bouteille_24)</td>
                            </tr>                                                                          
                            
                            
                        </table>
                        <table style="width: 60%; margin: 0 auto;"  class="boutons">
                            <tr>
                                <td style="text-align: center">
                                    <button title="Supprimer" value="Supprimer" type="button" id="supprimer_emballage" class="btn btn-default oufbutton  action"><i class="ouf-delete"></i>Supprimer</button>
                                </td>
                                <td style="text-align: center">
                                    <button title="Ajouter" value="Ajouter" type="button" id="materiel_emballage" class="btn btn-default oufbutton  action"><i class='ouf-ok'></i>Ajouter</button>
                                </td>
                                
                            </tr>
                        </table>
                        <div id="gradesmemballage"></div>
                        
                    </div>
                    <table style="width: 80%; margin: 0 auto; text-align: center">
                        
                    </table>
                </div>
            </div>
        }
    </div>
</div> 
<script>
    $('#formulaire').jqxValidator({
        rules: [

        ],
    });

     $('#formulaire').jqxWindow({ height: "95%", width: "95%", isModal: true, showCloseButton: true, theme: "ui-redmond", maxWidth: '1100' });
    $('#jqxTabs').jqxTabs({ height: 'auto', width: '100%', theme: "ui-redmond" });
    $("#Nom_Client").jqxInput({ placeHolder: "Nom Client ", height: 25, width: 280, theme: "ui-redmond", disabled: true, });

    $("#Solde_Initial_Liquide").jqxInput({ placeHolder: "Solde Initial", height: 25, width: 150, theme: "ui-redmond", disabled: true, rtl: true });
    $("#Solde_Initial_Emballage").jqxInput({ placeHolder: "Solde Initial", height: 25, width: 150, theme: "ui-redmond", disabled: true, rtl: true });
    
    $("#Versement_Liquide").jqxInput({ placeHolder: "Versement", height: 25, width: 150, theme: "ui-redmond" });
    $("#Consigne_Emballage").jqxInput({ placeHolder: "Consigne", height: 25, width: 150, theme: "ui-redmond" });
    $("#Solde_Final_Liquide").jqxInput({ placeHolder: "Solde Final", height: 25, width: 150, theme: "ui-redmond", disabled: true, rtl: true });
    $("#Solde_Final_Emballage").jqxInput({ placeHolder: "Solde Final", height: 25, width: 150, theme: "ui-redmond", disabled: true, rtl: true });

    $("#Montant_Liquide").jqxInput({ placeHolder: "Montant Liquide ", height: 25, width: 150, theme: "ui-redmond", disabled: true, rtl: true });
    $("#Montant_Emballage").jqxInput({ placeHolder: "Montant Emballage ", height: 25, width: 150, theme: "ui-redmond", disabled: true, rtl: true });
    $("#Montant_Emballage_Retour").jqxInput({ placeHolder: "Montant Emballage Retour ", height: 25, width: 150, theme: "ui-redmond", disabled: true, rtl: true });

    

    $("#Quantite_Casier_Liquide").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Quantite_Bouteille_Liquide").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });

    $("#Quantite_Casier_Emballage").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Quantite_Plastique_Emballage").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Quantite_Bouteille_Emballage").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });

    $("#Casier_12").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Plastique_12").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Bouteille_12").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Plastique_15").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Casier_15").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Bouteille_15").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Casier_24").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Plastique_24").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Bouteille_24").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });

    $('#Quantite_Casier_Liquide').on('keyup', function (event) {
        $("#Quantite_Casier_Emballage").val($('#Quantite_Casier_Liquide').val())
    });

    $('#Quantite_Bouteille_Liquide').on('keyup', function (event) {
        $("#Quantite_Bouteille_Emballage").val($('#Quantite_Bouteille_Liquide').val())
    });
   Recapitulatif = function (Montant_Liquide, Montant_Emballage, Montant_Retour_Emballage, Montant_Facture) {
        $("#Montant_Liquide").val(Montant_Liquide.toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
        $("#Montant_Emballage").val(Montant_Emballage.toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
        $("#Montant_Emballage_Retour").val(Montant_Retour_Emballage.toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
        $("#Montant_Facture").html(Montant_Facture.toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
        var final_liquide = parseInt($("#Solde_Initial_Liquide").val().replace(" ","")) + parseInt(Montant_Liquide.replace(" ","")) - parseInt($("#Versement_Liquide").val().replace(" ",""));
        var final_emballage = parseInt($("#Solde_Initial_Emballage").val().replace(" ","")) + parseInt(Montant_Emballage.replace(" ","")) - parseInt(Montant_Retour_Emballage.replace(" ","")) - parseInt($("#Consigne_Emballage").val().replace(" ",""));
        $("#Solde_Final_Liquide").val(final_liquide.toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
        $("#Solde_Final_Emballage").val(final_emballage.toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
    }
     Recapitulatif($("#Montant_Liquide").val(), $("#Montant_Emballage").val(), $("#Montant_Emballage_Retour").val(), $("#Montant_Facture").text());
    $('#Versement_Liquide').on('keyup', function (event) {      
        var final_liquide = parseInt($("#Solde_Initial_Liquide").val().replace(" ","")) + parseInt($("#Montant_Liquide").val().replace(" ","")) - parseInt($("#Versement_Liquide").val().replace(" ",""));
       
        $("#Solde_Final_Liquide").val(final_liquide.toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
    });
    $('#Consigne_Emballage').on('keyup', function (event) {
        var final_emballage = parseInt($("#Solde_Initial_Emballage").val().replace(" ","")) + parseInt($("#Montant_Emballage").val().replace(" ","")) - parseInt($("#Montant_Emballage_Retour").val().replace(" ","")) - parseInt($("#Consigne_Emballage").val().replace(" ",""));
        $("#Solde_Final_Emballage").val(final_emballage.toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
    });

     $(".action").off('click');
     $(".action").on('click', function () {
         $("#loaderSpace,#loader").show();
         var selectedRows = $("#gradesm").jqxGrid('getselectedrowindexes');
         var selectedRows_ = $("#gradesmemballage").jqxGrid('getselectedrowindexes');
         var identifiant = $(this).attr('id') + "Url";
         var url = $("#" + identifiant).attr("value");
         if (identifiant === 'supprimerUrl') {
             var tab = '';
             $.each(selectedRows, function (index, row) {
                 var ligne = $("#gradesm").jqxGrid('getrowdata', row);
                 if (tab == '')
                     tab = ligne.id;
                 else
                     tab = tab + ';' + ligne.id;
             });
             if (tab === '') {
                 $("#loaderSpace,#loader").hide();
                 return false;
             }
             else
                 url = url + tab;
         }
         if (identifiant === 'supprimer_emballageUrl') {
             var tab = '';
             $.each(selectedRows_, function (index, row) {
                 var ligne = $("#gradesmemballage").jqxGrid('getrowdata', row);
                 if (tab == '')
                     tab = ligne.id;
                 else
                     tab = tab + ';' + ligne.id;
             });
             if (tab === '') {
                 $("#loaderSpace,#loader").hide();
                 return false;
             }
             else
                 url = url + tab;
         }
         $.ajax({
             url: url,
             type: 'POST', // la méthode indiquée dans le formulaire (get ou post)
             data: $('form').serialize(), // je sérialise les données (voir plus loin), ici les $_POST             
             dataType: 'json',
             success: function (html) {

                 if ((identifiant === 'materiel_emballageUrl') || (identifiant === 'supprimer_emballageUrl')) {
                    
                        $("#Quantite_Casier_Liquide").val("");
                        $("#Quantite_Bouteille_Liquide").val("");
                        $("#Quantite_Casier_Emballage").val("");
                        $("#Quantite_Plastique_Emballage").val("");
                        $("#Quantite_Bouteille_Emballage").val("");
                        Recapitulatif(html[1], html[2], html[3], html[4]);
                      $("#gradesmemballage").jqxGrid('updatebounddata', 'cells');
                     $("#gradesmemballage").jqxGrid('clearselection');
                 } else {
                     
                     $("#Quantite_Casier_Liquide").val("");
                        $("#Quantite_Bouteille_Liquide").val("");
                        $("#Quantite_Casier_Emballage").val("");
                        $("#Quantite_Plastique_Emballage").val("");
                        $("#Quantite_Bouteille_Emballage").val("");
                        Recapitulatif(html[1], html[2], html[3], html[4]); 
                     $("#gradesm").jqxGrid('updatebounddata', 'cells');
                     $("#gradesm").jqxGrid('clearselection');
                 }

                 $("#grades").jqxGrid('clearselection');
                 $(".toast-item").remove();
                 $('body').append(html[0]);
                 $("#loaderSpace,#loader").hide();
             },
             error: function (jqXHR, exception) {
                 $("#loaderSpace,#loader").hide();
                 if (jqXHR.status === 0) {
                     alert('Not connect.\n Verify Network.');
                 } else if (jqXHR.status == 404) {
                     alert('Requested page not found. [404]');
                 } else if (jqXHR.status == 500) {
                     alert('Internal Server Error [500].');
                 } else if (exception === 'parsererror') {
                     alert('Requested JSON parse failed.');
                 } else if (exception === 'timeout') {
                     alert('Time out error.');
                 } else if (exception === 'abort') {
                     alert('Ajax request aborted.');
                 } else {
                     alert('Uncaught Error.\n' + jqXHR.responseText);
                 }
             }
         });
         return false;
     });

     var columnsDatam = [{
         text: '', filterable: false, menu: false, sortable: false,
         datafield: 'available', columntype: 'checkbox',
         renderer: function () {
             return '<div style=" margin-top: 5px;"></div>';
         },
         rendered: function (elementm) {
             $(elementm).jqxCheckBox({ theme: "ui-redmond", width: 16, height: 16, animationShowDelay: 0, animationHideDelay: 0 });
             columnCheckBoxm = $(elementm);
             $(elementm).on('change', function (event) {
                 var checkedm = event.args.checked;
                 var pageinfom = $("#gradesm").jqxGrid('getpaginginformation');
                 var pagenumm = pageinfom.pagenum;
                 var pagesizem = pageinfom.pagesize;
                 if (checkedm == null || updatingCheckStatem) return;
                 $("#gradesm").jqxGrid('beginupdate');
                 if (checkedm) {
                     $("#gradesm").jqxGrid('selectallrows');
                     $("#gradesm").jqxGrid('selectallrows', event.args.rowindex);
                 }
                 else if (checkedm == false) {
                     $("#gradesm").jqxGrid('clearselection');
                 }
                 var startrowm = pagenumm * pagesizem;
                 for (var i = startrowm; i < startrowm + pagesizem; i++) {
                     var boundindex = $("#gradesm").jqxGrid('getrowboundindex', i);
                     $("#gradesm").jqxGrid('setcellvalue', boundindex, 'available', event.args.checked);
                 }
                 $("#gradesm").jqxGrid('endupdate');
             });
             return true;
         }
     },
              { text: 'id', editable: false, filtertype: 'textbox', datafield: 'id', hidden: true },
             { text: 'Produit', editable: false, filtertype: 'textbox', datafield: 'Produit', width: '29%' },
             { text: 'Quantité', editable: false, filtertype: 'textbox', datafield: 'Quantite', cellsformat: 'd', width: '17.3%' },
             { text: 'PU Liquide', editable: false, filtertype: 'textbox', datafield: 'Prix_Liquide', cellsformat: 'd', width: '15%' },
             { text: 'Prix Emballage', editable: false, filtertype: 'textbox', datafield: 'Prix_Emballage', cellsformat: 'd', width: '15%' },
             { text: 'Montant', editable: false, filtertype: 'textbox', datafield: 'Total', cellsformat: 'd', width: '20%' },
     ];

     var urlm = $("#LoardUrlm").attr("value");

     //grid
     var sourcem =
     {
         datatype: "json",
         url: urlm,
         datafields: [
                     { name: 'id', type: 'string' },
                    { name: 'Produit', type: 'string' },
                    { name: 'Quantite_Casier_Liquide', type: 'number' },
                    { name: 'Quantite_Bouteille_Liquide', type: 'number' },
                    { name: 'Quantite_Casier_Emballage', type: 'number' },
                    { name: 'Quantite_Plastique_Emballage', type: 'number' },
                    { name: 'Quantite_Bouteille_Emballage', type: 'number' },
                    { name: 'Prix_Liquide_Vente', type: 'number' },
                    { name: 'Montant_Liquide', type: 'number' },
                    { name: 'Montant_Emballage', type: 'number' },
                    { name: 'Total', type: 'number' },
         ],
         cache: false,
         updaterow: function (rowid, rowdata, commit) {
             commit(true);
         },
         deleterow: function (rowid, commit) {
             commit(true);
         }
     };
     var columnCheckBoxm = null;
     var updatingCheckStatem = false;
     var dataadapterm = new $.jqx.dataAdapter(sourcem, {
         loadError: function (xhr, status, error) {
             alert(error);
         }
     });
     // initialize grades
     $("#gradesm").jqxGrid(
     {
         columnsresize: true,
         editable: true,
         width: '98%',
         source: dataadapterm,
         selectionmode: 'checkbox',
         sortable: false,
         pageable: false,
         autoheight: true,
         showfilterrow: false,
         filterable: false,
         theme: "ui-redmond",
         localization: getLocalization(),
         columns: [
            { text: 'id', editable: false, filtertype: 'textbox', datafield: 'id', hidden: true },
            { text: 'Produit', editable: false, align: 'center', filtertype: 'textbox', datafield: 'Produit', width: '20.7%' },
            { text: 'Casier', columngroup: 'Liquide', align: 'center', editable: true, filtertype: 'textbox', cellsalign: 'right', datafield: 'Quantite_Casier_Liquide', cellsformat: 'd', width: '8%', aggregates: ["sum"] },
            { text: 'Bouteille', columngroup: 'Liquide', align: 'center', editable: true, filtertype: 'textbox', cellsalign: 'right', datafield: 'Quantite_Bouteille_Liquide', cellsformat: 'd', width: '8%', aggregates: ["sum"] },
            { text: 'PU', columngroup: 'Liquide', align: 'center', editable: false, filtertype: 'textbox', cellsalign: 'right', datafield: 'Prix_Liquide_Vente', cellsformat: 'd', width: '8%' },
            { text: 'Casier', columngroup: 'Emballage', align: 'center', editable: true, filtertype: 'textbox', cellsalign: 'right', datafield: 'Quantite_Casier_Emballage', cellsformat: 'd', width: '8%', aggregates: ["sum"] },
            { text: 'Plastique', columngroup: 'Emballage', align: 'center', editable: true, filtertype: 'textbox', cellsalign: 'right', datafield: 'Quantite_Plastique_Emballage', cellsformat: 'd', width: '8%', aggregates: ["sum"] },
            { text: 'Bouteille', columngroup: 'Emballage', align: 'center', editable: true, filtertype: 'textbox', cellsalign: 'right', datafield: 'Quantite_Bouteille_Emballage', cellsformat: 'd', width: '8%', aggregates: ["sum"] },
            { text: 'Liquide', columngroup: 'Montant', align: 'center', editable: false, filtertype: 'textbox', cellsalign: 'right', datafield: 'Montant_Liquide', cellsformat: 'd', width: '8%' },
            { text: 'Emballage', columngroup: 'Montant', align: 'center', editable: false, filtertype: 'textbox', cellsalign: 'right', datafield: 'Montant_Emballage', cellsformat: 'd', width: '8%' },
            { text: 'Total', align: 'center', editable: false, filtertype: 'textbox', datafield: 'Total', cellsalign: 'right', cellsformat: 'd', width: '12.7%' },
        ],
        columngroups: [
                    { text: 'Liquide', align: 'center', name: 'Liquide' },
					{ text: 'Emballage', align: 'center', name: 'Emballage' },
					{ text: 'Montant', align: 'center', name: 'Montant' },
        ]
     });



     $("#gradesm").on('bindingcomplete', function (event) {
         $('#gradesm').jqxGrid({ pagesizeoptions: ['10', '20', '50'] });
         $('#gradesm').jqxGrid('pagesize', 10);
     });

    $("#gradesm").on('cellendedit', function (event) {
        if (args.datafield == "Quantite_Casier_Liquide") {
            if (!IsNumber_OUF(args.value) || parseInt(args.value) < 0) {
                $('#messages').jqxWindow('setContent', 'Cette valeur doit être un nombre positif');
                $('#messages').jqxWindow({ width: "auto" });
                $('#messages').jqxWindow({ height: "auto" });
                $('#messages').jqxWindow("open");
                return false;
            }
            else {
                var row = args.rowindex;
                var data = $('#gradesm').jqxGrid('getrowdata', row);
                Edit_Grille(data.id, 1, args.value);
            }

        } else if (args.datafield == "Quantite_Bouteille_Liquide") {
            if (!IsNumber_OUF(args.value) || parseInt(args.value) < 0) {
                $('#messages').jqxWindow('setContent', 'Cette valeur doit être un nombre positif');
                $('#messages').jqxWindow({ width: "auto" });
                $('#messages').jqxWindow({ height: "auto" });
                $('#messages').jqxWindow("open");
                return false;
            }
            else {
                var row = args.rowindex;
                var data = $('#gradesm').jqxGrid('getrowdata', row);
                Edit_Grille(data.id, 2, args.value);
            }

        } else if (args.datafield == "Quantite_Casier_Emballage") {
            if (!IsNumber_OUF(args.value) || parseInt(args.value) < 0) {
                $('#messages').jqxWindow('setContent', 'Cette valeur doit être un nombre positif');
                $('#messages').jqxWindow({ width: "auto" });
                $('#messages').jqxWindow({ height: "auto" });
                $('#messages').jqxWindow("open");
                return false;
            }
            else {
                var row = args.rowindex;
                var data = $('#gradesm').jqxGrid('getrowdata', row);
                Edit_Grille(data.id, 3, args.value);
            }

        } else if (args.datafield == "Quantite_Plastique_Emballage") {
            if (!IsNumber_OUF(args.value) || parseInt(args.value) < 0) {
                $('#messages').jqxWindow('setContent', 'Cette valeur doit être un nombre positif');
                $('#messages').jqxWindow({ width: "auto" });
                $('#messages').jqxWindow({ height: "auto" });
                $('#messages').jqxWindow("open");
                return false;
            }
            else {
                var row = args.rowindex;
                var data = $('#gradesm').jqxGrid('getrowdata', row);
                Edit_Grille(data.id, 4, args.value);
            }

        } else if (args.datafield == "Quantite_Bouteille_Emballage") {
            if (!IsNumber_OUF(args.value) || parseInt(args.value) < 0) {
                $('#messages').jqxWindow('setContent', 'Cette valeur doit être un nombre positif');
                $('#messages').jqxWindow({ width: "auto" });
                $('#messages').jqxWindow({ height: "auto" });
                $('#messages').jqxWindow("open");
                return false;
            }
            else {
                var row = args.rowindex;
                var data = $('#gradesm').jqxGrid('getrowdata', row);
                Edit_Grille(data.id, 5, args.value);
            }

        }
    });
    Edit_Grille = function (id, key, value) {
        $("#loaderSpace,#loader").show();

        $.ajax({
            url: '/Vente/Edit_Grille_1/?id=' + id + '&key=' + key + '&value=' + value, // le nom du fichier indiqué dans le formulaire
            type: 'GET', // la méthode indiquée dans le formulaire (get ou post)
            dataType: 'json'
        })
      .success(function (response) {
          Recapitulatif(response[1], response[2], response[3], response[4]);

          $("#gradesm").jqxGrid('updatebounddata', 'cells');
          $("#gradesm").jqxGrid('clearselection');
          $("body").append(response);
          $("#loaderSpace,#loader").hide();
      })
      .error(function () {
          alert('echeck');
          $("#loaderSpace,#loader").hide();
      });
    }


     // select or unselect rows when a checkbox is checked or unchecked. 
     $("#gradesm").on('cellvaluechanged', function (event) {
         if (event.args.value) {
             $("#gradesm").jqxGrid('selectrow', event.args.rowindex);
         }
         else {
             $("#gradesm").jqxGrid('unselectrow', event.args.rowindex);
         }

         // update the state of the column's checkbox. When all checkboxes on the displayed page are checked, we need to check column's checkbox. We uncheck it,
         // when there are no checked checkboxes on the page and set it to intederminate state when there is at least one checkbox checked on the page.  
         if (columnCheckBoxm) {
             var datainfom = $("#gradesm").jqxGrid('getdatainformation');
             var pagesizem = datainfom.paginginformation.pagesize;
             var pagenumm = datainfom.paginginformation.pagenum;
             var selectedRowsm = $("#gradesm").jqxGrid('getselectedrowindexes');
             var statem = false;
             var countm = 0;
             $.each(selectedRowsm, function () {
                 if (pagenumm * pagesizem <= this && this < pagenumm * pagesizem + pagesizem) {
                     countm++;
                 }
             });

             if (countm != 0) statem = null;
             if (countm == pagesizem) statem = true;
             if (countm == 0) statem = false;

             updatingCheckStatem = true;
             $(columnCheckBoxm).jqxCheckBox({ checked: statem });

             updatingCheckStatem = false;
         }
     });




     ////////////////////////////

     var columnsDatamemballage = [{
         text: '', filterable: false, menu: false, sortable: false,
         datafield: 'available', columntype: 'checkbox',
         renderer: function () {
             return '<div style=" margin-top: 5px;"></div>';
         },
         rendered: function (elementmemballage) {
             $(elementmemballage).jqxCheckBox({ theme: "ui-redmond", width: 16, height: 16, animationShowDelay: 0, animationHideDelay: 0 });
             columnCheckBoxmemballage = $(elementmemballage);
             $(elementmemballage).on('change', function (event) {
                 var checkedmemballage = event.args.checked;
                 var pageinfomemballage = $("#gradesmemballage").jqxGrid('getpaginginformation');
                 var pagenummemballage = pageinfomemballage.pagenumemballage;
                 var pagesizememballage = pageinfomemballage.pagesize;
                 if (checkedmemballage == null || updatingCheckStatememballage) return;
                 $("#gradesmemballage").jqxGrid('beginupdate');
                 if (checkedmemballage) {
                     $("#gradesmemballage").jqxGrid('selectallrows');
                     $("#gradesmemballage").jqxGrid('selectallrows', event.args.rowindex);
                 }
                 else if (checkedmemballage == false) {
                     $("#gradesmemballage").jqxGrid('clearselection');
                 }
                 var startrowmemballage = pagenummemballage * pagesizememballage;
                 for (var i = startrowmemballage; i < startrowmemballage + pagesizememballage; i++) {
                     var boundindex = $("#gradesmemballage").jqxGrid('getrowboundindex', i);
                     $("#gradesmemballage").jqxGrid('setcellvalue', boundindex, 'available', event.args.checked);
                 }
                 $("#gradesmemballage").jqxGrid('endupdate');
             });
             return true;
         }
     },
             { text: 'id', editable: false, filtertype: 'textbox', datafield: 'id', hidden: true },
             { text: 'Emballage', editable: false, filtertype: 'textbox', datafield: 'Emballage', width: '29%' },
             { text: 'Casier', editable: false, filtertype: 'textbox', datafield: 'Casier_Plein', cellsformat: 'd', width: '17.3%' },
             { text: 'Plastique', editable: false, filtertype: 'textbox', datafield: 'Casier_Vide', cellsformat: 'd', width: '15%' },
             { text: 'Bouteille', editable: false, filtertype: 'textbox', datafield: 'Bouteille', cellsformat: 'd', width: '15%' },
             { text: 'Montant', editable: false, filtertype: 'textbox', datafield: 'Montant', cellsformat: 'd', width: '20%' },
     ];
     var urlmemballage = $("#LoardUrlmemballage").attr("value");

     //grid
     var sourcememballage =
     {
         datatype: "json",
         url: urlmemballage,
         datafields: [
                    { name: 'id', type: 'string' },
                   { name: 'Emballage', type: 'string' },
                   { name: 'Quantite_Casier', type: 'number' },
                   { name: 'Quantite_Plastique', type: 'number' },
                   { name: 'Quantite_Bouteille', type: 'number' },
                   { name: 'Montant', type: 'number' },
         ],
         cache: false,
         updaterow: function (rowid, rowdata, commit) {
             commit(true);
         },
         deleterow: function (rowid, commit) {
             commit(true);
         }
     };
     var columnCheckBoxmemballage = null;
     var updatingCheckStatememballage = false;
     var dataadaptermemballage = new $.jqx.dataAdapter(sourcememballage, {
         loadError: function (xhr, status, error) {
             alert(error);
         }
     });
     // initialize grades
     $("#gradesmemballage").jqxGrid(
     {
         columnsresize: true,
         editable: false,
         width: '98%',
         source: dataadaptermemballage,
         selectionmode: 'checkbox',
         sortable: false,
         pageable: false,
         autoheight: true,
         showfilterrow: false,
         filterable: false,
         theme: "ui-redmond",
         localization: getLocalization(),
         columns: [
              { text: 'id', editable: false, filtertype: 'textbox', datafield: 'id', hidden: true },
            { text: 'Emballage', editable: false, filtertype: 'textbox', datafield: 'Emballage', width: '29.1%' },
            { text: 'Casier', editable: false, filtertype: 'textbox', datafield: 'Quantite_Casier', cellsformat: 'd', width: '17.3%' },
            { text: 'Plastique', editable: false, filtertype: 'textbox', datafield: 'Quantite_Plastique', cellsformat: 'd', width: '15%' },
            { text: 'Bouteille', editable: false, filtertype: 'textbox', datafield: 'Quantite_Bouteille', cellsformat: 'd', width: '15%' },
            { text: 'Montant', editable: false, filtertype: 'textbox', datafield: 'Montant', cellsformat: 'd', width: '21%' },
         ]
     });



     $("#gradesmemballage").on('bindingcomplete', function (event) {
         $('#gradesmemballage').jqxGrid({ pagesizeoptions: ['10', '20', '50'] });
         $('#gradesmemballage').jqxGrid('pagesize', 10);
     });

     // select or unselect rows when a checkbox is checked or unchecked. 
     $("#gradesmemballage").on('cellvaluechanged', function (event) {
         if (event.args.value) {
             $("#gradesmemballage").jqxGrid('selectrow', event.args.rowindex);
         }
         else {
             $("#gradesmemballage").jqxGrid('unselectrow', event.args.rowindex);
         }

         // update the state of the column's checkbox. When all checkboxes on the displayed page are checked, we need to check column's checkbox. We uncheck it,
         // when there are no checked checkboxes on the page and set it to intederminate state when there is at least one checkbox checked on the page.  
         if (columnCheckBoxmemballage) {
             var datainfomemballage = $("#gradesmemballage").jqxGrid('getdatainformation');
             var pagesizememballage = datainfomemballage.paginginformation.pagesize;
             var pagenummemballage = datainfomemballage.paginginformation.pagenumemballage;
             var selectedRowsmemballage = $("#gradesmemballage").jqxGrid('getselectedrowindexes');
             var statememballage = false;
             var countmemballage = 0;
             $.each(selectedRowsmemballage, function () {
                 if (pagenummemballage * pagesizememballage <= this && this < pagenummemballage * pagesizememballage + pagesizememballage) {
                     countmemballage++;
                 }
             });

             if (countmemballage != 0) statememballage = null;
             if (countmemballage == pagesizememballage) statem = true;
             if (countmemballage == 0) statememballage = false;

             updatingCheckStatememballage = true;
             $(columnCheckBoxmemballage).jqxCheckBox({ checked: statememballage });

             updatingCheckStatememballage = false;
         }
     });






     //////////////////

     $('#formulaire').on('close', function (event) {
         $('#formulaire').jqxWindow("destroy");
         $("#grades").jqxGrid('updatebounddata', 'cells');
         $("#grades").jqxGrid('clearselection');
     });
    
    /////////////////////////////////////////////
</script>
<style >
    .section {
        padding:3px;
    }
    #gradesm, #gradesmemballage {
        margin: 8px;
    }
     #Quantite_Liquide
    {
        visibility:hidden;
        display:none;
    }
    

     th{
        background: none repeat scroll 0 0 #FFF;
        border-color: #999999;
        color: #000000;
        font-family: Lucida Grande,Lucida Sans,Arial,sans-serif;
        font-size: 13px;
        text-align: center;
        font-weight: bold;
        height: auto;
        outline: medium none;
        overflow: hidden;
        padding: 5px;
        white-space: nowrap;
        line-height: 1.231;
        -moz-user-select: none;
        font-style: normal;
        cursor: default;
        direction: ltr;
    }

    table.td {
        background: url("images/redmond/ui-bg_inset-hard_100_fcfdfd_1x100.png") repeat-x scroll 50% bottom #FCFDFD;
        border-color: #999999;
        color: #222222;
        font-family: Lucida Grande,Lucida Sans,Arial,sans-serif;
        font-size: 13px;
        line-height: 20px;
        vertical-align: top;
        padding: 5px;
    }

    table.encadrer, tr.encadrer, td.encadrer, th {
        border: thin solid #7c7777;
    }
    
    
</style>